#include <dos.h>
#include <conio.h>
#include "opendoor.h"      // Must be included in all doors
#include "d4all.h"
#include "colors.h"
#include "clear.h"
#include "anykey.h"
#include "yes.h"
#include "fairreg.h"
#include "button.h"
#include "open.h"

#ifdef __TURBOC__
   extern unsigned _stklen = 10000;
#endif

// main.c
FUNCDEF void opentalk(void);
FUNCDEF void generate(int);
FUNCDEF void help(void);
FUNCDEF void playgame(void);    // switch statements for playgame
FUNCDEF void editmenu(void);
FUNCDEF void DoUserEditor(void); // allow sysop to edit user record
FUNCDEF void save_file(void);   // save file on exit

FUNCDEF void bottommenu(void);  // bottom quit menu, etc.

// -----------------------------------------------------------

CODE4 cb ;
extern DATA4 *dbf_address ;
extern FIELD4 *dreadkey1, *dreadkey2, *bbsname, *sysop ;

DATA4 *dbf_talk ;
FIELD4 *t_talk, *t_number  ;
TAG4 *tag_t_number ;

FIELD4  *sssnumber, *sssgame, *ssspaid, *ssscomment,
   *city,
   *ssstype, *sssday, *sssmonth, *sssyear,
   *sssnode, *address1, *address2,
   *state, *zip, *hac, *hphone, *wac, *wphone,
   *bbssystem ;

int nosetup = 0;

// -----------------------------------------------------------

int gamenum = 0 ; // set up for no game, for anykey  use
// for saving in database:
int onedone = 0 ; // one done already
int saveyes = 0 ;
char mycomment[41];
char mypaid[10];
char mytype[3];
char blurb[31];
int  numeric = 0 ;

char systemname[33];
char sysopname[33];

extern FILE *stream;
extern int logmode ;
extern int shortgame ;

int localmode ; // are running local mode, no .def file param passed
int editmode = 0 ;
int logcount = 0 ;
int doall = 0 ;      // do all keys
int dorepeat = 0 ;   // repeat for additional key (not all)
int do_first = 0 ;
int final = 1 ;

extern char destination[11];
char dest1[11];
char dest2[11];
char string2[20];
char string[11];
unsigned long key = 0;

// -----------------------------------------------------------
int main(int argc,char *argv[])
{

od_control.od_disable = DIS_NAME_PROMPT;
ssscolors();

if(argc>1)      // path & name of drop file
  strncpy(od_control.info_path,argv[1],59);   // if pass more than just file name

localmode = argc ; // define whether more than one var or not

// moved this stuff here after odoor out of memory errorwhen it was below the argv line:
strcpy(od_registered_to,"Nannette K. Thacker"); // OpenDoors registration info
od_registration_key=2542862336L ;

od_control.od_nocopyright = FALSE ;
od_control.od_force_local = TRUE;
od_set_statusline( STATUS_NONE );

if(localmode == 1)   // if running locally, don't show the statusline
    od_set_statusline(STATUS_NONE);



// -----------------------------------------------------------

od_init();
od_log_write("Initializing Codebase.");
d4init(&cb) ;
cb.open_error = 0 ; // don't give an error when opening a dbf that doesn't exist, so can create if NULL
cb.safety = 0 ;   // won't erase files when d4create is used
		  // if database is damaged, allow to create over old one
cb.exclusive = 0 ;     // open not exclusively
cb.read_lock = 0 ;
cb.lock_attempts = -1 ;
cb.read_only = 0 ;     // open not read only
cb.read_only = 1 ;     // open read or not read only
od_log_write("Opening Talk.dbf.");
//opencall("opentalk",0);

//opencall("initialize",2); // initialize without phone and message

// -----------------------------------------------------------

od_control.od_before_exit=save_file;

if(localmode == 1)   // if running locally, don't do a timeout
  od_control.od_inactivity = 0 ;

	 opentalk();
//opencall("opentalk",0);
buttoncall("open",0);
playgame();

return(0);

}  // end main

// -----------------------------------------------------------


// -----------------------------------------------------------
void redraw()
{
     clearscreen(1);
     bottommenu();
}  // end redraw

// -----------------------------------------------------------


// -----------------------------------------------------------

void save_file(void)        // Function to save player info before exit
{     // (called before door termination)
    od_printf("Goodbye!");
    d4close_all(&cb) ;

}  // end save_file


// -----------------------------------------------------------


// -----------------------------------------------------------
void bottommenu()
{
int start = 1 ;
clearscreen(start);
od_set_cursor(start++,1) ;
od_printf("`b f r`NEW! `b bl`SSS Key Generator By:`b r` Nannette K. Thacker");

colorback(BLACK);
od_set_cursor(start++,1) ;
od_printf("`b y`(`b c`A`b y`)ll 11 door package `b y`(`b c`9`b y`) Door Package ");
od_set_cursor(start++,1) ;
od_printf("`b y`(`b c`D`b y`)read (`b c`S`b y`)pike (`b c`W`b y`)ake");
od_set_cursor(start++,1) ;
od_printf("(`b c`P`b y`)unch (`b c`J`b y`)acob (`b c`T`b y`)rekkie");
od_set_cursor(start++,1) ;
od_printf("(`b c`F`b y`)ury (`b c`R`b y`)age");
od_set_cursor(start++,1) ;
od_printf("(`b c`1`b y`) FAIR IGM (both keys)");
od_set_cursor(start++,1) ;
od_printf("(`b c`0`b y`) FAIR new key");
od_set_cursor(start++,1) ;
od_printf("(`b c`2`b y`) PHANTOM");
od_set_cursor(start++,1) ;
od_printf("(`b c`3`b y`) MOONCHAT");
od_set_cursor(start++,1) ;
od_printf("(`b c`4`b y`) LEVIATHAN");
od_set_cursor(start++,1) ;
od_printf("(`b c`5`b y`) 12 PACK!");
od_set_cursor(start++,1) ;
od_printf("`b g`(`b c`I`b g`)nstructions  (`b c`Q`b g`)uit (`b c`L`b g`)og Keys On `b r`(`b c`X`b r`)Log Keys Off");

clearset(3,70);
    if(logmode == 1)
       od_printf("`b g`LOG ON ");
    else
      od_printf("`b r`LOG OFF");


}




void gameswitch(int whichone, int passvar)
{

if(passvar == 0 && whichone == 0)
   ; // just to use it so it will stop giving error

}



void playgame()
{

int command = 0;                  // get command from user

e4set(&cb, 0) ;// was below the do  before anything else

int quitgame = 0 ;
clearscreen(1);
bottommenu();


do        // do while loop
{


   od_clear_keybuffer();         //  Clear keyboard
   od_set_cursor(22,78) ;          // move cursor down out of mission plan
   command =  od_get_key(TRUE) ; // FALSE = DON'T WAIT FOR USER INPUT

   switch(command)
   {
    case 'l':
    case 'L':
      logmode = 1 ;
      redraw();
      break ;
    case 'x':
    case 'X':
		logmode = 0 ;
		redraw();
		break ;
	 case '5':    // 12 PACK!
		doall = 1 ;
		generate(1);
		generate(2);
		generate(3);
		generate(4);
		generate(5);
		generate(6);
		generate(8);
		generate(9);
		generate(7); // Phantom
		generate(11); // Moonchat
		generate(10);   // FAIR upgrade
		generate(100);   // FAIR lfair31.zip or sooner
		generate(12); // Leviathan
		doall = 0 ;
		do_first = 0 ;
		break ;
		break ;
	 case 'a':
	 case 'A':
		doall = 1 ;
		generate(1);
		generate(2);
		generate(3);
		generate(4);
		generate(5);
		generate(6);
		generate(8);
		generate(9);
		generate(7); // Phantom
		generate(11); // Moonchat
		generate(10);   // FAIR upgrade
		generate(100);   // FAIR lfair31.zip or sooner
		doall = 0 ;
		do_first = 0 ;
		break ;
	 case '9':
		doall = 2 ;
		generate(1);
		generate(2);
		generate(3);
		generate(4);
		generate(5);
		generate(6);
		generate(8);
		generate(9);
      generate(10);   // FAIR upgrade
      generate(100);   // FAIR lfair31.zip or sooner
      doall = 0 ;
      do_first = 0 ;
      break ;
    case 'd': // dread
    case 'D':
      generate(1);
      break ;
    case 's':   // spike
    case 'S':
      generate(2);
		break ;
    case 'p':   // punchline
    case 'P':
      generate(3);
      break ;
    case 'w':    // don't wake the sysop
    case 'W':
      generate(4);
      break ;
    case 'j':    //jacob's ladder
    case 'J':
      generate(5);
      break ;
	 case 't':    // trekkie tags
    case 'T':
      generate(6);
      break ;
    case '2':    // PHANTOM
      generate(7);
      break ;
	 case '3':    // moonchat
		generate(11);
		break ;
	 case '4':    // LEVIATHAN
		generate(12);
		break ;
	 case 'f':    // fury
    case 'F':
      generate(8);
      break ;
    case 'r':    /// rage
    case 'R':
      generate(9);
      break ;
    case '0':    // LORD FAIR IGM
      generate(10);  // new key
      break ;
    case '1':    // LORD FAIR IGM
      generate(10); // new standalone key
      generate(100);  // old igm key
      break ;
    case 'I':
    case 'i':
       help();
       redraw();
       break ;
    case 'q':
    case 'Q':
	quitgame = 1 ;
	od_exit(10,FALSE);              // Again OpenDoors does the rest

    default :                        // NO KEY PRESSED
	;
   }       // Switch loop until quit to BBS or logoff

 } while(quitgame == 0);   // end do while

}  // end playgame


void help()
{
clearscreen(1);
od_control.od_page_pausing = TRUE ;
colormitem(WHITE) ;
od_send_file("HELP.TXT");
anykey();
}



void generate(int which)

{

int start = 1 ;
redraw();
if(onedone == 1 && doall == 0) // if one has already been done, and not doing all
{ clearscreen(1);
  clearset(1,1);
colormitem(YELLOW) ;
  od_printf("`b c`%s ", sysopname);
  od_printf("of %s", systemname);
  clearset(2,1);
colormitem(WHITE) ;
  od_printf("Do you wish to use the same SYSOP/BBS as the previous key?");
  if(yesorno(3,1) != 0)
  {
   do_first = 1 ;           // set do_first to 1 so won't repeat if doing all
   dorepeat = 1 ;
  }
  else
  {  dorepeat = 0 ;
     do_first = 0 ;
  }
}
onedone = 1 ; // yes one has been done // set that has been done once

if( (doall != 0 || dorepeat == 1 ) && which > 1)
   do_first = 1 ;           // set do_first to 1 so won't repeat if doing all

if( (doall != 0 || dorepeat == 1 ) && which == 1)
  final = 0 ;

if(logmode == 1)
{


 if(do_first == 0)
 {
 itoa(++logcount, string, 10);
 strcat(string,".FIL");
 clearset(start++,1);
 od_printf("%s",string);

 /* open a file for update */
 stream = fopen(string, "w+");
 /* write some data to the file */
 //fprintf(stream, "%d %c %f", i, c, f);
 }
}


if(do_first == 0)
{
  clearscreen(1);
/*
  clearset(start++,1);
  od_printf("`b m`Please enter net address if applicable: `b w`");
  fprintf(stream, "Net address:  ");
  clearset(start++,1);
  od_input_str(string2,20,32,127);
  fprintf(stream, " %s\n",string2);
*/
  fprintf(stream, "All Shining Star files can be frequed at 1:291/60 or downloaded\n");
  fprintf(stream, "from 316-522-7829 or 316-522-7641 or FTP at ftp.southwind.net /users/n/nannette\n");
}
start++;

clearset(start++,1);
od_printf("----------------------------===******===----------------------------");
if(logmode == 1)
  fprintf(stream,"----------------------------===******===----------------------------\n");

if(do_first == 0 && which != 100 ) //
{
clearset(start++,1);
od_printf("`c`Please note: `b c`If your key ends with punctuation, IT IS PART OF THE KEY!");
if(logmode == 1)
   fprintf(stream, "Please note: If your key ends with punctuation, IT IS PART OF THE KEY! \n");
if(logmode == 1)
   fprintf(stream, "	     Key is CASE SENSITIVE! \n");

clearset(start++,1);
 od_printf("THANK YOU FOR REGISTERING! KEY INSTRUCTIONS FOR ");
 if(logmode == 1)
   fprintf(stream, "THANK YOU FOR REGISTERING! KEY INSTRUCTIONS FOR ");

}

clearset(start++,1);
if(which ==1) // dr. dread
{  od_printf("DR. DREAD:");
if(logmode == 1)
   fprintf(stream, "DR. DREAD:\n");
}
else if(which ==2) // spiked!
{  od_printf("SPIKED!:");
if(logmode == 1)
   fprintf(stream, "SPIKED!:\n");
}
else if(which ==3) // punch
{  od_printf("PUNCHLINE!:");
if(logmode == 1)
   fprintf(stream, "PUNCHLINE!:\n");
}
else if(which ==4) // wake
{  od_printf("DON'T WAKE SYSOP:");
if(logmode == 1)
   fprintf(stream, "DON'T WAKE SYSOP:\n");
}
else if(which ==5) // JACOB
{  od_printf("JACOB'S LADDER:");
if(logmode == 1)
   fprintf(stream, "JACOB'S LADDER:\n");
}
else if(which ==6) // TREKKIE
{  od_printf("TREKKIE TAGS:");
if(logmode == 1)
   fprintf(stream, "TREKKIE TAGS:\n");
}
else if(which ==7) // PHANTOM
{  od_printf("PHANTOM:");
 if(logmode == 1)
   fprintf(stream, "PHANTOM:\n");
}
else if(which ==8) // FURY
{  od_printf("DOOR FURY:");
 if(logmode == 1)
   fprintf(stream, "DOOR FURY:\n");
}
else if(which ==9) // RAGE
{  od_printf("DOOR RAGE:");
 if(logmode == 1)
   fprintf(stream, "DOOR RAGE:\n");
}
else if(which == 11) // MOONCHAT
{  od_printf("MOONCHAT:");
 if(logmode == 1)
	fprintf(stream, "MOONCHAT:\n");
}
else if(which == 12)
{  od_printf("LEVIATHAN:");
 if(logmode == 1)
	fprintf(stream, "LEVIATHAN:\n");
}
else if(which == 10) // COUNTY FAIR UPGRADE
{  od_printf("COUNTY FAIR:");
 if(logmode == 1)
   fprintf(stream, "COUNTY FAIR:\n");
}
else if(which == 100) // LORD COUNTY FAIR
{
  clearset(start++,1);
  od_printf("LORD COUNTY FAIR Registration Key LFAIR31.ZIP or earlier");
  clearset(start++,1);
  od_printf("=================================");
  clearset(start++,1);
  od_printf("Sysop: ");
  clearset(start++,1);
if(doall != 0 || dorepeat == 1)
 od_printf("%s",sysopname);
else
  od_input_str(sysopname,32,32,127);
  c4trim_n(sysopname,sizeof(sysopname) ) ;

clearset(start++,1);
od_printf("BBS  : ");
clearset(start++,1);
if(doall != 0 || dorepeat == 1)
 od_printf("%s",systemname);
else
  od_input_str(systemname,35,32,127);
  c4trim_n(systemname,sizeof(systemname) )  ;


char systemtemp[33];
char sysoptemp[33];
strcpy(systemtemp,systemname);
strcpy(sysoptemp,sysopname); // copy to temp so can copy back

dofair(sysopname, systemname) ; // generate the key
ultoa(key,dest1,10);
clearset(start++,1);
od_printf("Registration key: %0.10lu", key);

strcpy(systemname,systemtemp);
strcpy(sysopname,sysoptemp);   // copy back so will be according to input case

if(logmode == 1)
{ fprintf(stream, "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n");
  fprintf(stream, "LORD COUNTY FAIR Registration Key\n");
  fprintf(stream, "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n");
  fprintf(stream, "Thanks for registering!\n");
  fprintf(stream, "The LORD COUNTY FAIR Sysop & BBS Name fields are *not* case sensitive.\n");
  fprintf(stream, "You may enter them UPPER or Lower Case as desired.\n");
  fprintf(stream, "If New Installation     : type INSTFAIR INSTALL to install & enter key.\n");
  fprintf(stream, "If Existing Installation: type FAIR REGISTER    to enter key.\n");
  fprintf(stream, "Registration key: %0.10lu\n", key);
  fprintf(stream, "Sysop: %s\n", sysopname);
  fprintf(stream, "BBS  : %s\n\n", systemname);
}

}

if(which != 100)
{
 clearset(start++,1);
 od_printf("`b w`In order to register, go into sysop mode from DOS by typing: ");

 if(logmode == 1)
   fprintf(stream, "In order to register, go into sysop mode from DOS by typing:\n");

clearset(start++,1);
if(which ==1) // dr. dread
{ if(logmode == 1)
   fprintf(stream, "dread sysop\n");
  od_printf("`b y`dread sysop");
}
else if(which ==2)
{ if(logmode == 1)
   fprintf(stream, "spike sysop\n");
  od_printf("`b y`spike sysop");
}
else if(which ==3 || which == 5 || which == 6)
{ if(logmode == 1)
   fprintf(stream, "sssgame sysop\n");
  od_printf("`b y`sssgame sysop");
}
else if(which ==4 )
{ if(logmode == 1)
   fprintf(stream, "wake sysop\n");
  od_printf("`b y`wake sysop");
}
else if(which ==7)
{ if(logmode == 1)
   fprintf(stream, "phan sysop\n");
  od_printf("`b y`phan sysop");
}
else if(which ==8)
{ if(logmode == 1)
   fprintf(stream, "fury sysop\n");
  od_printf("`b y`fury sysop");
}
else if(which ==9)
{ if(logmode == 1)
   fprintf(stream, "rage sysop\n");
  od_printf("`b y`rage sysop");
}
else if(which ==11)
{ if(logmode == 1)
	fprintf(stream, "moon sysop\n");
  od_printf("`b y`moon sysop");
}
else if(which ==12)
{ if(logmode == 1)
	fprintf(stream, "reef sysop\n");
  od_printf("`b y`reef sysop");
}
else if(which ==10)
{ if(logmode == 1)
   fprintf(stream, "fair sysop\n");
  od_printf("`b y`fair sysop");

 clearset(start++,1);
 od_printf("`b g`Due to hacking of the FAIR key, this key is good for the upgrade.");
 if(logmode == 1)
 {	fprintf(stream, "Due to hacking of the FAIR key, this key is good for the upgrade available\n");
	fprintf(stream, "for download on 316-522-7829 or FREQ as FAIR at 1:291/60\n");
 }
}

 clearset(start++,1);
 od_printf("`b g`Select \"Enter Registration Key\", the screen will say:");
 if(logmode == 1)
   fprintf(stream, "Select \"Enter Registration Key\", the screen will say:\n");

 clearset(start++,1);
 od_printf("`b m`Please enter the password given to you by Nannette: ");
 if(logmode == 1)
    fprintf(stream, "Please enter the password given to you by Nannette: \n");
 clearset(start++,1);
 od_printf("`b c`913");
 if(logmode == 1)
   fprintf(stream, "913 \n");

clearset(start++,1);
od_printf("`b m`Please enter your BBS name EXACTLY as shown with key information: `b w`");
if(logmode == 1)
   fprintf(stream, "Please enter your BBS name EXACTLY as shown with key information: \n");
clearset(start++,1);
if( (doall != 0 || dorepeat == 1 ) && which > 1)
 od_printf("%s",systemname);
else
  od_input_str(systemname,35,32,127);
  c4trim_n(systemname,sizeof(systemname) )  ;
if(logmode == 1)
   fprintf(stream, "%s \n",systemname);
clearset(start++,1);
od_printf("`b m`Please enter the SYSOP name EXACTLY as shown with key information: `b w`");
if(logmode == 1)
   fprintf(stream, "Please enter the SYSOP name EXACTLY as shown with key information: \n");
clearset(start++,1);
if( (doall != 0 || dorepeat == 1 ) && which > 1)
 od_printf("%s",sysopname);
else
  od_input_str(sysopname,32,32,127);
  c4trim_n(sysopname,sizeof(sysopname) ) ;
if(logmode == 1)
   fprintf(stream, "%s \n",sysopname);

clearset(start++,1);
od_printf("`b m`Please enter your first registration key number: CASE SENSITIVE");
if(logmode == 1)
   fprintf(stream, "Please enter your first registration key number: CASE SENSITIVE\n");
clearset(start++,1);
buttoncall("general4",which);
strcpy(dest1,destination);

clearset(start++,1);
od_printf("`b m`Please enter your second registration key number: CASE SENSITIVE");
if(logmode == 1)
   fprintf(stream, "Please enter your second registration key number: CASE SENSITIVE\n");
clearset(start++,1);
buttoncall("general5",which) ;
strcpy(dest2,destination);

regdat(sysopname, systemname, which); // which = gamenum

}   // end if which != 100 // all keys but not IGM

anykey();
clearscreen(1);

/*
if(do_first == 1)
{ redraw();
  return ;
}
*/

  start = 1 ;
  clearset(start++,1);

if(do_first == 1 && saveyes == 1)
{
  // don't ask the question just do it
}
else if(do_first == 1 && saveyes == 0)
{ redraw();
  return ;
}
else
{

/* add this here for roger garrod
   redraw();
   saveyes = 0 ; // don't save
  return ;
*/

  od_printf("Do you want to save this in the database?");
  if(yesorno(start++,1) == 0)
  {
   redraw();
   saveyes = 0 ; // don't save
   return ;
  }
  else
    saveyes = 1 ;
}

  buttoncall("addressopen",0); // open address
  struct date currdate;  // get current date function
  getdate(&currdate);
  sssgame = d4field(dbf_address, "sssgame");
  ssstype = d4field(dbf_address,"ssstype");
  sssnumber = d4field(dbf_address,"sssnumber");
  sssnode = d4field(dbf_address, "sssnode");
  sssday = d4field(dbf_address, "sssday");
  sssmonth = d4field(dbf_address, "sssmonth");
  sssyear = d4field(dbf_address, "sssyear");
  ssspaid = d4field(dbf_address, "ssspaid");
  ssscomment = d4field(dbf_address, "ssscomment");
  city = d4field(dbf_address,"city");
  state = d4field(dbf_address,"state");
  zip = d4field(dbf_address,"zip");
  address1 = d4field(dbf_address,"address1");
  address2 = d4field(dbf_address,"address2");
  hac = d4field(dbf_address,"hac");
  hphone = d4field(dbf_address,"hphone");
  wac = d4field(dbf_address,"wac");
  wphone = d4field(dbf_address,"wphone");
  bbssystem = d4field(dbf_address,"system");

//   tag_sssnumber = d4tag(dbf_address, "sssnumber") ;

  long newnum ;
//   d4tag_select( dbf_address, tag_sssnumber ) ;
  d4bottom(dbf_address);
  newnum = f4long(sssnumber);

if(do_first == 0) // if is the first one to save,, ask the questions
{
  clearset(start++,1);
  od_printf("What TYPE is this? X=Xchange, F=Free, B=Beta Site, P=Paid, O=Other");
  clearset(start++,1);
  od_input_str(mytype,2,32,127);
  c4trim_n(mytype,sizeof(mytype) ) ;
  clearset(start++,1);
  od_printf("Comments/Swap for:");
  clearset(start++,1);
  od_input_str(mycomment,40,32,127);
  c4trim_n(mycomment,sizeof(mycomment) ) ;
}

  d4append_start(dbf_address, 0) ;
  d4blank(dbf_address);


if( doall != 0 && which > 1) // don't ask amount again if doing all
  strcpy(mypaid, ""); // set to zero, amount saved with first door
else
{
  clearset(start++,1);
  od_printf("Amount paid: ");
  od_input_str(mypaid,9,32,127);

 if(do_first == 0) // if is the first one
 {
  clearset(start++,1);
  od_printf("Address 1: ");
  od_input_str(blurb,25,32,127);
  f4assign(address1, blurb) ;

  clearset(start++,1);
  od_printf("Address 2: ");
  od_input_str(blurb,25,32,127);
  f4assign(address2, blurb) ;

  clearset(start++,1);
  od_printf("City: ");
  od_input_str(blurb,20,32,127);
  f4assign(city, blurb) ;

  clearset(start++,1);
  od_printf("State: ");
  od_input_str(blurb,2,32,127);
  f4assign(state, blurb) ;

  clearset(start++,1);
  od_printf("Zip: ");
  od_input_str(blurb,9,32,127);
  f4assign(zip, blurb) ;

  clearset(start++,1);
  od_printf("AC:" );
  od_input_str(blurb,3,32,127);
  f4assign(hac, blurb) ;
  f4assign(wac, blurb) ;

  clearset(start++,1);
  od_printf("Voice Phone: ");
  od_input_str(blurb,7,32,127);
  f4assign(hphone, blurb) ;

  clearset(start++,1);
  od_printf("BBS Phone: ");
  od_input_str(blurb,7,32,127);
  f4assign(wphone, blurb) ;

  clearset(start++,1);
  od_printf("BBS System: ");
  od_input_str(blurb,30,32,127);
  f4assign(bbssystem, blurb) ;
 }
}

      f4assign(bbsname, systemname) ;
      f4assign(sysop, sysopname) ;
      f4assign(sssnode, string2) ;
      f4assign_long(sssnumber,newnum + 1);
      f4assign_long(sssgame,which ); // game #
      f4assign_long(sssday,currdate.da_day );
      f4assign_long(sssmonth,currdate.da_mon );
      f4assign_long(sssyear,currdate.da_year );
      f4assign(dreadkey1,dest1);
      if(which == 100) // if IGM skip second key
	; // skip
      else
	f4assign(dreadkey2,dest2);

      f4assign(ssstype, mytype) ;
      f4assign(ssscomment, mycomment) ;
      f4assign(ssspaid, mypaid) ;

   d4append(dbf_address) ;


buttoncall("addressclose",0); // close address
redraw();

/*
if(final == 1 && logmode == 1)
{
// close the file
fclose(stream);
}
*/


} // end generate

void opentalk()
{

  dbf_talk = d4open( &cb, "talk" ) ;
  e4exit_test( &cb ) ;
  t_number = d4field( dbf_talk, "t_number" ) ;
  t_talk = d4field( dbf_talk, "t_talk" ) ;

	tag_t_number = d4tag(dbf_talk, "t_number") ;
	d4tag_select( dbf_talk, tag_t_number ) ;
	d4top( dbf_talk ) ;

}


